
import java.util.Vector;


void setup() {

  size( 600, 600 );
  
  roundTable = new RoundTable( 12 );
  
  roundTable.haveDrinkTogether();
}


RoundTable roundTable;


class RoundTable {

  Vector<Diner> diners;

  RoundTable( int n ) {
  
    diners = new Vector<Diner>();
    
    Diner first = new Diner( 1 );
    diners.add( first );
    Diner diner = first;
   
    for ( int k = 2;  k <= n;  k = k+1 ) {
    
      Diner next = new Diner( k );
      diners.add( next );
      diner.identifyLeftNeighbor( next );
      diner = next;
    }
    diner.identifyLeftNeighbor( first );
  }
  
  void haveDrinkTogether() {
  
    Diner diner = diners.firstElement();
    diner.graspJar();
    
    for ( int n = diners.size();  n > 2;  n = n-1 ) {
    
      diner = diner.passJar();
      diner.pourWine();
      diner = diner.passJar();
    }
    print( "last two diners: " + diner.number() );
    diner = diner.leftNeighbor();
    println( ", " + diner.number() );
  }

}  // class RoundTable


class Diner {

  int myNum;
  Diner onMyLeft;
  boolean haveJar;
  boolean canDrink;
  
  Diner( int n ) {
  
    myNum = n;
    onMyLeft = null;
    haveJar = false;
    canDrink = false;
  }
  
  int number() {
  
    return myNum;
  }
  
  void identifyLeftNeighbor( Diner d ) {
  
    onMyLeft = d;
  }
  
  void getDrink() {
  
    canDrink = true;
  }
  
  void graspJar() {
  
    haveJar = true;
  }
  
  void pourWine() {
  
    if ( haveJar ) {
      onMyLeft.getDrink();
      identifyLeftNeighbor( onMyLeft.leftNeighbor() );
    }
  }
  
  Diner passJar() {
  
    if ( haveJar ) {
      onMyLeft.graspJar();
      haveJar = false;
    }
    return onMyLeft;
  }
  
  Diner leftNeighbor() {
  
    return onMyLeft;
  }

}  // class Diner
